﻿function on_notify_data(name, data) {
	if(name == "lastfm_update" && data == 1) {
		username = read(username_file);
		api_key = read(api_key_file);
		startplay = true;
		load();
	}
}

function on_size() {
	ww = window.Width;
	wh = window.Height;
	offset = 0;
}

function on_paint(gr) {
	gr.FillSolidRect(0, 0, ww, wh, g_backcolor);
	offset = Math.round(offset);
	gr.SetTextRenderingHint(5);
	if(username.length == 0 || api_key.length != 32) {
		gr.GdiDrawText("Please use the context menu to set your Last.fm username and API KEY.", g_font, g_textcolor, 0, 0, ww, wh, DT_VCENTER | DT_CENTER | DT_WORDBREAK | DT_CALCRECT | DT_NOPREFIX);
	} else if(g_metadb) {
		textheight = gr.MeasureString(g_text, g_font, 6, 0, ww-12, 9999999999).Height;
		gr.DrawString(g_text, g_font, g_textcolor, 6, offset + 34, ww-12, textheight, StringFormat(StringAlignment.Near, StringAlignment.Near, StringTrimming.EllipsisPath));
		gr.FillSolidRect(0, 0, ww, 34, g_backcolor);
		gr.GdiDrawText(username, gdi.Font(font, 16, 1), g_textcolor_hl, 6, 6, ww-77, 24, DT_VCENTER  | DT_END_ELLIPSIS | DT_CALCRECT | DT_NOPREFIX);
		gr.DrawImage(lfm_img, ww-60, 8, 50, 18, 0, 0, 50, 18);
		gr.DrawLine(10, 29, ww-20, 29, 1, g_textcolor_hl);
		gr.FillGradRect(5, 29,10, 1, 0, RGB(255,255,255), g_textcolor_hl);
		gr.FillGradRect(ww-20, 29,10, 1, 0, g_textcolor_hl,RGB(255,255,255));
	} else {
		gr.GdiDrawText("[no selection]", g_font, g_textcolor, 0, 0, ww, wh, DT_VCENTER | DT_CENTER | DT_WORDBREAK | DT_CALCRECT | DT_NOPREFIX);
	}
}

function on_playback_new_track() {
	startplay = true;
	on_item_focus_change();
}

function on_metadb_changed() {
	if(title == fb.TitleFormat("%title%").EvalWithMetadb(g_metadb)) return;
	!fb.IsPlaying && load();
}

function on_item_played(g_metadb) {
	load();
}

function on_mouse_wheel(delta) {
	applyDelta(delta, defoffset);
}

function on_mouse_lbtn_down(x, y) {
	g_drag = true;
	g_drag_y = y;
}

function on_mouse_move(x,y) {
	if (x > ww-60 && x < ww-10 && y > 8 && y < 26) {
		g_tooltip.Activate();
		window.SetCursor(IDC_HAND);
	} else {
		g_tooltip.Deactivate();
		window.SetCursor(IDC_ARROW);
		if (g_drag) {
			applyDelta((y - g_drag_y)/30, defoffset);
			g_drag_y = y;
		}
	}
}

function on_mouse_lbtn_up(x, y) {
	if(x > ww-60 && x < ww-10 && y > 8 && y < 26) {
		WshShell.run("http://www.last.fm/user/" + username);
	} else {
		g_drag = false;
	}
}

function on_mouse_rbtn_up(x, y) {
	var _menu = window.CreatePopupMenu();
	var _languages = window.CreatePopupMenu();
	var idx;
	_menu.AppendMenuItem(username.length > 0 && api_key.length == 32 && g_metadb ? MF_STRING : MF_GRAYED, 1, "Update");
	_menu.AppendMenuItem(MF_SEPARATOR, 0, 0);
	_menu.AppendMenuItem(MF_STRING, 2, "Set your Last.fm username");
	_menu.AppendMenuItem(MF_STRING, 3, "Set your API KEY");
	if(utils.IsKeyPressed(0x10)) {
		_menu.AppendMenuItem(MF_SEPARATOR, 0, 0);
		_menu.AppendMenuItem(MF_STRING, 9, "Properties");
		_menu.AppendMenuItem(MF_STRING, 10, "Configure...");
	}
	idx = _menu.TrackPopupMenu(x, y);
	switch(idx) {
	case 1:
		startplay = true;
		load();
		break;
	case 2:
		username = text_input_box("LastFM", "Please enter your Last.fm username", username_file);
		window.NotifyOthers("lastfm_update", 1);
		startplay = true;
		load();
		break;
	case 3:
		api_key = text_input_box("Last.FM", "Please enter your Last.fm API KEY\n\nhttp://www.last.fm/api/account", api_key_file);
		window.NotifyOthers("lastfm_update", 1);
		startplay = true;
		load();
		break;
	case 9:
		window.ShowProperties();
		break;
	case 10:
		window.ShowConfigure();
		break;
	}
	_languages.Dispose();
	_menu.Dispose();
	return true;
}